<?php
//==========================================------
// p4DAV.php  Implements a  Perforce WebDAV server
//==========================================------
// Derived from the open source HTTP_WebDAV_Server class (0.99.1)
// ********************************************
// Runs as a helper for Apache HTTP requests of this pattern...
//       http://[thisdomain]/p4/[Perforce path without initial //]
// Requires a directory "davroot" in the Apache document root for temporary files
// Requires the service of the Perforce command-line client P4.
// Triggered by the following directive included in Apache's conf.ini file...
//       AliasMatch ^/p4.*  [somewhere]/p4DAV.php
// Serves a single Perforce repository whose IP address is specified below
// Resides in a directory [somewhere] with these companion files...
// 1) p4DAV.php [this file] (heavily modified from davserver.php)
// 2) DepotServer.php  (heavily modified from FileSystem.php)
// 3) DAVServer.php  (derived with slight mods from Server.php)
// 4) Tools  (a directory, unmodified from open-source distribution) containing...
//  4.1) _parse_lockinfo.php
//  4.2) _parse_propfind.php
//  4.3) _parse_proppatch.php
//*************************************************
// You must edit the section below to your specifications
//*************************************************
$prefix = '/p4';  //  Webserver DAV trigger prefix (Apache AliasMatch)
$base = $_SERVER['DOCUMENT_ROOT'].'/davroot/'; // directory for temp files
$depot_host='192.168.1.3';
//$depot_host = 'public.perforce.com';            // Perforce repository
$depot_port = '1666';                                     // Perforce contact port
$depot_agent = '/usr/local/bin/p4';                 // Perforce command-line client
$admin_user = 'daniel_sabsay';                       // Perforce admin user
$admin_passwd = 'p4webdav';                         // Perforce admin password
//************************************************

require_once realpath('.').'/DepotServer.php';
$URI = $_SERVER['REQUEST_URI'];
$path = (strlen($URI)>strlen($prefix))? substr($URI,strlen($prefix)):'/';
$method = strtoupper($_SERVER['REQUEST_METHOD']);

// PHP messages destroy XML output, so switch them off
ini_set('display_errors', E_USER_NOTICE);

//****************
//   BASIC  LOG  HEADER
//****************
$log = '---';
$req_hdrs = apache_request_headers();
unset($req_hdrs['Accept-Language']);  // suppress junk
$lt = localtime(time(),true);
$ts = $lt['tm_hour'].':'.$lt['tm_min'].':'.$lt['tm_sec'];
$log .= '  '.date('m/d/Y',time()).'['.$ts."] ".$_SERVER['REMOTE_ADDR'].'=>'.$method.' '.$path;
error_log($log); $log = '';
foreach ($req_hdrs as $k=>$v) { $log .= $k.'='.$v.'--'; }
error_log($log);

//**************
//   INVOKE SERVER
//**************
$depot = new Depot_Filesystem; // instanciate server class
$depot->prefix = $prefix;
$depot->base = $base;
$depot->path = $path;
$depot->depot_host = $depot_host;
$depot->depot_port = $depot_port;
$depot->depot_agent = $depot_agent;
$depot->admin_user = $admin_user; // used for deleting faux directory placeholders
$depot->admin_passwd = $admin_passwd;
$depot->ServeRequest($method); // process request
flush();  // release any buffered output to client

//*****************
//   BASIC  LOG  TRAILER
//*****************
//error_log(join('--',headers_list()));  // PHP5 only
error_log('--------');
?>